﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<Data> _tickDataPoints = new ObservableCollection<Data>();
            _tickDataPoints.Add(new Data{Close=100, Date = new DateTime(2013, 03, 13, 1, 15, 00), High=105, Low=98, Open=103, Label = "Item1"});
            _tickDataPoints.Add(new Data { Close = 102, Date = new DateTime(2013, 03, 13, 1, 15, 00), High = 107, Low = 98, Open = 105, Label = "Item2" });
            _tickDataPoints.Add(new Data { Close = 104, Date = new DateTime(2013, 03, 13, 1, 30, 00), High = 109, Low = 100, Open = 107, Label = "Item3" });
            _tickDataPoints.Add(new Data { Close = 106, Date = new DateTime(2013, 03, 13, 1, 45, 00), High = 111, Low = 102, Open = 109, Label = "Item4" });
            _tickDataPoints.Add(new Data { Close = 108, Date = new DateTime(2013, 03, 13, 2, 00, 00), High = 113, Low = 104, Open = 111, Label = "Item5" });
            _tickDataPoints.Add(new Data { Close = 110, Date = new DateTime(2013, 03, 13, 2, 15, 00), High = 115, Low = 106, Open = 113, Label = "Item6" });
            _tickDataPoints.Add(new Data { Close = 112, Date = new DateTime(2013, 03, 13, 2, 30, 00), High = 117, Low = 108, Open = 115, Label = "Item7" });
            _tickDataPoints.Add(new Data { Close = 114, Date = new DateTime(2013, 03, 13, 2, 45, 00), High = 119, Low = 110, Open = 117, Label = "Item8" });
            _tickDataPoints.Add(new Data { Close = 116, Date = new DateTime(2013, 03, 13, 3, 00, 00), High = 121, Low = 112, Open = 119, Label = "Item9" });
            _tickDataPoints.Add(new Data { Close = 118, Date = new DateTime(2013, 03, 13, 3, 15, 00), High = 123, Low = 114, Open = 121, Label = "Item10" });
            _tickDataPoints.Add(new Data { Close = 120, Date = new DateTime(2013, 03, 13, 3, 30, 00), High = 125, Low = 116, Open = 123, Label = "Item11" });
            _tickDataPoints.Add(new Data { Close = 122, Date = new DateTime(2013, 03, 13, 3, 45, 00), High = 127, Low = 118, Open = 125, Label = "Item12" });
            _tickDataPoints.Add(new Data { Close = 124, Date = new DateTime(2013, 03, 13, 4, 00, 00), High = 129, Low = 120, Open = 127, Label = "Item13" });
            _tickDataPoints.Add(new Data { Close = 126, Date = new DateTime(2013, 03, 13, 4, 15, 00), High = 131, Low = 122, Open = 129, Label = "Item14" });
            _tickDataPoints.Add(new Data { Close = 128, Date = new DateTime(2013, 03, 13, 4, 30, 00), High = 133, Low = 124, Open = 131, Label = "Item15" });
            _tickDataPoints.Add(new Data { Close = 130, Date = new DateTime(2013, 03, 13, 4, 45, 00), High = 135, Low = 126, Open = 133, Label = "Item16" });
            _tickDataPoints.Add(new Data { Close = 132, Date = new DateTime(2013, 03, 13, 5, 00, 00), High = 137, Low = 128, Open = 135, Label = "Item17" });
            _tickDataPoints.Add(new Data { Close = 134, Date = new DateTime(2013, 03, 13, 5, 15, 00), High = 139, Low = 130, Open = 137, Label = "Item18" });
            _tickDataPoints.Add(new Data { Close = 136, Date = new DateTime(2013, 03, 13, 5, 30, 00), High = 141, Low = 132, Open = 139, Label = "Item19" });
            _tickDataPoints.Add(new Data { Close = 138, Date = new DateTime(2013, 03, 13, 5, 45, 00), High = 143, Low = 134, Open = 141, Label = "Item20" });
            _tickDataPoints.Add(new Data { Close = 140, Date = new DateTime(2013, 03, 13, 6, 00, 00), High = 145, Low = 136, Open = 143, Label = "Item21" });

            ObservableCollection<ChartData> _fillDataPoints = new ObservableCollection<ChartData>();
            _fillDataPoints.Add(new ChartData { Date=new DateTime(2013, 03, 13, 2, 15, 00), Value1=115, Value2 = 115, Value3 = 115});
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 2, 35, 00), Value1 = 117, Value2 = 117, Value3 = 117 });
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 2, 55, 00), Value1 = 120, Value2 = 120, Value3 = 120 });
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 3, 15, 00), Value1 = 123, Value2 = 123, Value3 = 117 });
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 3, 45, 00), Value1 = 117, Value2 = 117, Value3 = 117 });
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 4, 15, 00), Value1 = 131, Value2 = 131, Value3 = 131 });
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 4, 25, 00), Value1 = 133, Value2 = 133, Value3 = 133 });
            _fillDataPoints.Add(new ChartData { Date = new DateTime(2013, 03, 13, 4, 45, 00), Value1 = 135, Value2 = 135, Value3 = 135 });

            
            (PriceChart.Series[0] as FinancialPriceSeries).ItemsSource = _tickDataPoints;
            (PriceChart.Series[1] as PointSeries).ItemsSource = _fillDataPoints;

            (PriceChart.Axes[0] as CategoryDateTimeXAxis).ItemsSource = _tickDataPoints;
            (PriceChart.Axes[1] as CategoryDateTimeXAxis).ItemsSource = _fillDataPoints;
        }
    }

    public class Data : INotifyPropertyChanged
    {
        private int open;
        private int close;
        private int high;
        private int low;
        private int value;
        private string label;
        private DateTime date;


        public DateTime Date
        {
            get { return date; }
            set
            {
                date = value;
                PropChanged("Date");
            }
        }


        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int Open
        {
            get { return open; }
            set
            {
                open = value;
                PropChanged("Open");
            }
        }

        public int Close
        {
            get { return close; }
            set
            {
                close = value;
                PropChanged("Close");
            }
        }

        public int High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public int Low
        {
            get { return low; }
            set
            {
                low = value;
                PropChanged("Low");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class ChartData
    {
        public DateTime Date { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }
    }
}